
subroutine DLLEigenvaluesAndVectors(switch,dim, machep,areal,aimgy,diago,vecre,vecim)

  ! This subroutine computes Eigenvalues and Vectors for Hermitian matrices
  ! using EISPACK routines (cf internet).
  ! WRHagen 20221030
  !
IMPLICIT NONE
  !DEC$ ATTRIBUTES DLLEXPORT::DLLEigenvaluesAndVectors
  !DEC$ ATTRIBUTES STDCALL::DLLEigenvaluesAndVectors

  ! Declare calling parameters
    INTEGER*4, INTENT(IN) :: switch, dim
    REAL*8, INTENT(IN) :: machep, areal(dim,dim), aimgy(dim,dim)
    REAL*8, INTENT(OUT) :: diago(dim)
    REAL*8, INTENT(OUT) :: vecre(dim,dim), vecim(dim,dim)

  ! Declare local parameters
    REAL*8 :: offdi(dim), dummy(dim), tau(dim,dim)

    INTEGER ierr, j1, j2

 ! Body of DLLEigenvaluesAndVectors
    
    DO  j1 = 1, dim
        DO  j2 = 1, dim
            vecre(j1,j2) = 0.
            vecim(j1,j2) = 0.
        END DO
        vecre(j1,j1) = 1.
    END DO
    CALL HTRIDI (dim,dim,areal,aimgy,diago,offdi,dummy,tau)
    ierr = 0
    CALL TQL2   (machep,dim,dim,diago,offdi,vecre,ierr)
    IF (switch .EQ. 1) THEN
        CALL HTRIBK (dim,dim,areal,aimgy,tau,dim,vecre,vecim)
    END IF


end subroutine DLLEigenvaluesAndVectors
